| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkExtentRCBPartitioner Class Reference

`#include <vtkExtentRCBPartitioner.h>`

Inheritance diagram for vtkExtentRCBPartitioner:
[legend]
Collaboration diagram for vtkExtentRCBPartitioner:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkExtentRCBPartitioner * | NewInstance () const
void | PrintSelf (ostream &oss, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetNumberOfPartitions (const int N)
| Set/Get the number of requested partitions. More...
void | SetGlobalExtent (int imin, int imax, int jmin, int jmax, int kmin, int kmax)
| Set/Get the global extent array to be partitioned. More...
void | SetGlobalExtent (int ext[6])
virtual void | SetDuplicateNodes (vtkTypeBool)
| On/Off DuplicateNodes between partitions. More...
virtual vtkTypeBool | GetDuplicateNodes ()
virtual void | DuplicateNodesOn ()
virtual void | DuplicateNodesOff ()
virtual void | SetNumberOfGhostLayers (int)
| Set/Get macro for the number of ghost layers. More...
virtual int | GetNumberOfGhostLayers ()
virtual int | GetNumExtents ()
| Returns the number of extents. More...
void | Partition ()
| Partitions the extent. More...
void | GetPartitionExtent (const int idx, int ext[6])
| Returns the extent of the partition corresponding to the given ID. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkExtentRCBPartitioner * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkExtentRCBPartitioner * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkExtentRCBPartitioner ()
| ~vtkExtentRCBPartitioner () override
void | Reset ()
| Resets the partitioner to the initial state, all previous partition extents are cleared. More...
void | ExtendGhostLayers (int ext[6])
| Given an extent, this method will create ghost layers on each side of the boundary in each dimension. More...
void | GetGhostedExtent (int ext[6], const int minIdx, const int maxIdx)
| Givent an extent and the min/max of the dimension we are looking at, this method will produce a ghosted extent which is clamped within the given global extent. More...
void | AcquireDataDescription ()
| Gets the structured data-description based on the givenn global extent. More...
void | GetExtent (const int idx, int ext[6])
| Returns the extent at the position corresponding to idx. More...
void | AddExtent (int ext[6])
| Adds the extent to the end of the list of partitioned extents. More...
void | ReplaceExtent (const int idx, int ext[6])
| Replaces the extent at the position indicated by idx with the provided extent. More...
void | SplitExtent (int parent[6], int s1[6], int s2[6], int splitDimension)
| Splits the extent along the given dimension. More...
int | GetNumberOfTotalExtents ()
| Returns the total number of extents. More...
int | GetNumberOfNodes (int ext[6])
| Computes the total number of nodes for the given structured grid extent. More...
int | GetNumberOfCells (int ext[6])
| Computes the total number of cells for the given structured grid extent. More...
int | GetLongestDimensionLength (int ext[6])
| Returns the length of the longest dimension. More...
int | GetLongestDimension (int ext[6])
| Returns the longest edge. More...
void | PrintExtent (const std::string &name, int ext[6])
| A convenience method for debugging purposes. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | NumberOfGhostLayers
int | DataDescription
int | GlobalExtent [6]
int | NumberOfPartitions
int | NumExtents
vtkTypeBool | DuplicateNodes
bool | ExtentIsPartitioned
std::vector< int > | PartitionExtents
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

This method partitions a global extent to N partitions where N is a user supplied parameter.

Definition at line 32 of file vtkExtentRCBPartitioner.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkExtentRCBPartitioner::Superclass

Definition at line 36 of file vtkExtentRCBPartitioner.h.

## Constructor & Destructor Documentation

## ◆ vtkExtentRCBPartitioner()

vtkExtentRCBPartitioner::vtkExtentRCBPartitioner | ( |  | ) |
| protected

## ◆ ~vtkExtentRCBPartitioner()

vtkExtentRCBPartitioner::~vtkExtentRCBPartitioner | ( |  | ) |
| override protected

## Member Function Documentation

## ◆ New()

static vtkExtentRCBPartitioner* vtkExtentRCBPartitioner::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkExtentRCBPartitioner::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkExtentRCBPartitioner::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkExtentRCBPartitioner* vtkExtentRCBPartitioner::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkExtentRCBPartitioner::NewInstanceInternal | ( |  | ) | const
| protected virtual

## ◆ NewInstance()

vtkExtentRCBPartitioner* vtkExtentRCBPartitioner::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkExtentRCBPartitioner::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| override virtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ SetNumberOfPartitions()

void vtkExtentRCBPartitioner::SetNumberOfPartitions | ( | const int | N | ) |
| inline

Set/Get the number of requested partitions.

Definition at line 43 of file vtkExtentRCBPartitioner.h.

## ◆ SetGlobalExtent() [1/2]

void vtkExtentRCBPartitioner::SetGlobalExtent | ( | int | imin,
|  | int | imax,
|  | int | jmin,
|  | int | jmax,
|  | int | kmin,
|  | int | kmax
| ) |  |
| inline

Set/Get the global extent array to be partitioned.

The global extent is packed as follows: [imin,imax,jmin,jmax,kmin,kmax]

Definition at line 57 of file vtkExtentRCBPartitioner.h.

## ◆ SetGlobalExtent() [2/2]

void vtkExtentRCBPartitioner::SetGlobalExtent | ( | int | ext[6] | ) |
| inline

Definition at line 67 of file vtkExtentRCBPartitioner.h.

## ◆ SetDuplicateNodes()

virtual void vtkExtentRCBPartitioner::SetDuplicateNodes | ( | vtkTypeBool |  | ) |
| virtual

On/Off DuplicateNodes between partitions.

Default is On.

## ◆ GetDuplicateNodes()

virtual vtkTypeBool vtkExtentRCBPartitioner::GetDuplicateNodes | ( |  | ) |
| virtual

## ◆ DuplicateNodesOn()

virtual void vtkExtentRCBPartitioner::DuplicateNodesOn | ( |  | ) |
| virtual

## ◆ DuplicateNodesOff()

virtual void vtkExtentRCBPartitioner::DuplicateNodesOff | ( |  | ) |
| virtual

## ◆ SetNumberOfGhostLayers()

virtual void vtkExtentRCBPartitioner::SetNumberOfGhostLayers | ( | int |  | ) |
| virtual

Set/Get macro for the number of ghost layers.

## ◆ GetNumberOfGhostLayers()

virtual int vtkExtentRCBPartitioner::GetNumberOfGhostLayers | ( |  | ) |
| virtual

## ◆ GetNumExtents()

virtual int vtkExtentRCBPartitioner::GetNumExtents | ( |  | ) |
| virtual

Returns the number of extents.

## ◆ Partition()

void vtkExtentRCBPartitioner::Partition | ( |  | ) |

Partitions the extent.

## ◆ GetPartitionExtent()

void vtkExtentRCBPartitioner::GetPartitionExtent | ( | const int | idx,
|  | int | ext[6]
| ) |  |

Returns the extent of the partition corresponding to the given ID.

## ◆ Reset()

void vtkExtentRCBPartitioner::Reset | ( |  | ) |
| inline protected

Resets the partitioner to the initial state, all previous partition extents are cleared.

Definition at line 116 of file vtkExtentRCBPartitioner.h.

## ◆ ExtendGhostLayers()

void vtkExtentRCBPartitioner::ExtendGhostLayers | ( | int | ext[6] | ) |
| protected

Given an extent, this method will create ghost layers on each side of the boundary in each dimension.

The ghost layers however will be restricted to the given global extent.

## ◆ GetGhostedExtent()

void vtkExtentRCBPartitioner::GetGhostedExtent | ( | int | ext[6],
|  | const int | minIdx,
|  | const int | maxIdx
| ) |  |
| inline protected

Givent an extent and the min/max of the dimension we are looking at, this method will produce a ghosted extent which is clamped within the given global extent.

Definition at line 137 of file vtkExtentRCBPartitioner.h.

## ◆ AcquireDataDescription()

void vtkExtentRCBPartitioner::AcquireDataDescription | ( |  | ) |
| protected

Gets the structured data-description based on the givenn global extent.

## ◆ GetExtent()

void vtkExtentRCBPartitioner::GetExtent | ( | const int | idx,
|  | int | ext[6]
| ) |  |
| protected

Returns the extent at the position corresponding to idx.

## ◆ AddExtent()

void vtkExtentRCBPartitioner::AddExtent | ( | int | ext[6] | ) |
| protected

Adds the extent to the end of the list of partitioned extents.

## ◆ ReplaceExtent()

void vtkExtentRCBPartitioner::ReplaceExtent | ( | const int | idx,
|  | int | ext[6]
| ) |  |
| protected

Replaces the extent at the position indicated by idx with the provided extent.

## ◆ SplitExtent()

void vtkExtentRCBPartitioner::SplitExtent | ( | int | parent[6],
|  | int | s1[6],
|  | int | s2[6],
|  | int | splitDimension
| ) |  |
| protected

Splits the extent along the given dimension.

## ◆ GetNumberOfTotalExtents()

int vtkExtentRCBPartitioner::GetNumberOfTotalExtents | ( |  | ) |
| protected

Returns the total number of extents.

It's always the 2^N where N is the number of subdivisions.

## ◆ GetNumberOfNodes()

int vtkExtentRCBPartitioner::GetNumberOfNodes | ( | int | ext[6] | ) |
| protected

Computes the total number of nodes for the given structured grid extent.

## ◆ GetNumberOfCells()

int vtkExtentRCBPartitioner::GetNumberOfCells | ( | int | ext[6] | ) |
| protected

Computes the total number of cells for the given structured grid extent.

## ◆ GetLongestDimensionLength()

int vtkExtentRCBPartitioner::GetLongestDimensionLength | ( | int | ext[6] | ) |
| protected

Returns the length of the longest dimension.

## ◆ GetLongestDimension()

int vtkExtentRCBPartitioner::GetLongestDimension | ( | int | ext[6] | ) |
| protected

Returns the longest edge.

## ◆ PrintExtent()

void vtkExtentRCBPartitioner::PrintExtent | ( | const std::string & | name,
|  | int | ext[6]
| ) |  |
| protected

A convenience method for debugging purposes.

## Member Data Documentation

## ◆ NumberOfGhostLayers

int vtkExtentRCBPartitioner::NumberOfGhostLayers
| protected

Definition at line 205 of file vtkExtentRCBPartitioner.h.

## ◆ DataDescription

int vtkExtentRCBPartitioner::DataDescription
| protected

Definition at line 206 of file vtkExtentRCBPartitioner.h.

## ◆ GlobalExtent

int vtkExtentRCBPartitioner::GlobalExtent[6]
| protected

Definition at line 207 of file vtkExtentRCBPartitioner.h.

## ◆ NumberOfPartitions

int vtkExtentRCBPartitioner::NumberOfPartitions
| protected

Definition at line 208 of file vtkExtentRCBPartitioner.h.

## ◆ NumExtents

int vtkExtentRCBPartitioner::NumExtents
| protected

Definition at line 209 of file vtkExtentRCBPartitioner.h.

## ◆ DuplicateNodes

vtkTypeBool vtkExtentRCBPartitioner::DuplicateNodes
| protected

Definition at line 211 of file vtkExtentRCBPartitioner.h.

## ◆ ExtentIsPartitioned

bool vtkExtentRCBPartitioner::ExtentIsPartitioned
| protected

Definition at line 216 of file vtkExtentRCBPartitioner.h.

## ◆ PartitionExtents

std::vector<int> vtkExtentRCBPartitioner::PartitionExtents
| protected

Definition at line 218 of file vtkExtentRCBPartitioner.h.

The documentation for this class was generated from the following file:

- Common/ExecutionModel/vtkExtentRCBPartitioner.h